{$APPTYPE CONSOLE}

var
  x, y, u, v, hh: array[1..100000] of Integer;
  H, MaxOffset, MinLength, MaxLength: Integer;
  N: Integer;
  i, j: Integer;  

  procedure Swap(var a, b: Integer);
  var
    tmp: Integer;
  begin
    tmp := a;
    a := b;
    b := tmp;
  end;

  procedure Shuffle;
  var
    k1, k2: Integer;
    i: Integer;
  begin
    for i := 1 to 1000 + N div 100 do
    begin
      k1 := Random(N)+1;
      k2 := Random(N)+1;
      Swap(x[k1], x[k2]);
      Swap(y[k1], y[k2]);
      Swap(u[k1], u[k2]);
      Swap(v[k1], v[k2]);
      Swap(hh[k1], hh[k2]);
    end; 
  end;

begin
  Val(ParamStr(1), H, i);
  Val(ParamStr(2), MaxOffset, i);
  Val(ParamStr(3), MinLength, i);
  Val(ParamStr(4), MaxLength, i);
  Val(ParamStr(5), RandSeed, i);
  for i := 1 to H do
  begin
    Inc(N);
    x[N] := Random(MaxOffset+1);
    u[N] := x[N] + Random(MaxLength-MinLength+1) + MinLength;
    y[N] := i;
    v[N] := i+1;
    hh[N] := Random(50)+1;
  end;
  Shuffle;

  Writeln(N);
  for i := 1 to N do
    Writeln(x[i], ' ', y[i], ' ', u[i], ' ', v[i], ' ', hh[i]);
end.