{$R+}
uses
  Math;

type
  THouse = record x1, y1, x2, y2, h: Integer; end;

  function IsectArea(a1, a2, ah, b1, b2, bh: Integer): Integer;
  begin
    Result := 2 * Max((Min(a2, b2) - Max(a1, b1)) * Min(ah, bh), 0);
  end;

var
  f: TextFile;
  i, j, s, N: Integer;
  a: array [1..100000] of THouse;
begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, N);
  for i := 1 to N do
    with a[i] do
      Read(f, x1, y1, x2, y2, h);
  CloseFile(f);

  s := 0;
  for i := 1 to N do
    with a[i] do
      Inc(s, ((x2 - x1) + (y2 - y1)) * 2 * h + (x2 - x1) * (y2 - y1));

  for i := 1 to N do
    for j := i + 1 to N do begin
      if
        (Min(a[i].x2, a[j].x2) > Max(a[i].x1, a[j].x1)) and 
        (Min(a[i].y2, a[j].y2) > Max(a[i].y1, a[j].y1))
      then begin
        Writeln(i, ' ', j);
        Halt(99);
      end;
        
      if (a[i].x2 = a[j].x1) or (a[i].x1 = a[j].x2) then
        Dec(s, IsectArea(a[i].y1, a[i].y2, a[i].h, a[j].y1, a[j].y2, a[j].h));
      if (a[i].y2 = a[j].y1) or (a[i].y1 = a[j].y2) then
        Dec(s, IsectArea(a[i].x1, a[i].x2, a[i].h, a[j].x1, a[j].x2, a[j].h));
    end;

  AssignFile(f, 'output.txt'); Rewrite(f);
  Writeln(f, s);
  CloseFile(f);
end.
