{$APPTYPE CONSOLE}

var
  x, y, u, v, hh: array[1..100000] of Integer;
  W, H, mh, p: Integer;
  N: Integer;
  i, j: Integer;  

  procedure Swap(var a, b: Integer);
  var
    tmp: Integer;
  begin
    tmp := a;
    a := b;
    b := tmp;
  end;

  procedure Shuffle;
  var
    k1, k2: Integer;
    i: Integer;
  begin
    for i := 1 to N - 1 do
    begin
      k1 := i;
      k2 := Random(N - i) + i;
      Swap(x[k1], x[k2]);
      Swap(y[k1], y[k2]);
      Swap(u[k1], u[k2]);
      Swap(v[k1], v[k2]);
      Swap(hh[k1], hh[k2]);
    end; 
  end;

begin
  Val(ParamStr(1), W, i);
  Val(ParamStr(2), H, i);
  Val(ParamStr(3), mh, i);
  Val(ParamStr(4), p, i);
  Val(ParamStr(5), RandSeed, i);
  for i := 1 to W do
  begin
    for j := 1 to H do
    begin
      Inc(N);
      if Random(100) < p then begin
        x[N] := i * 10 + 5; y[N] := j * 10 + 5;
        u[N] := i * 10 + 6; v[N] := j * 10 + 6;
      end
      else begin
        x[N] := i * 10; y[N] := j * 10;
        u[N] := i * 10 + 10; v[N] := j * 10 + 10;
      end;
      hh[N] := Random(mh) + 1;
    end;
  end;
  Shuffle;

  Writeln(N);
  for i := 1 to N do
    Writeln(x[i], ' ', y[i], ' ', u[i], ' ', v[i], ' ', hh[i]);
end.