{$APPTYPE CONSOLE}

var
  x, y, u, v, hh: array[1..100000] of Integer;
  H, k, L: Integer;
  XY: string;
  N: Integer;
  i, j: Integer;  

  procedure Swap(var a, b: Integer);
  var
    tmp: Integer;
  begin
    tmp := a;
    a := b;
    b := tmp;
  end;

  procedure Shuffle;
  var
    k1, k2: Integer;
    i: Integer;
  begin
    for i := 1 to N - 1 do
    begin
      k1 := i;
      k2 := Random(N - i) + i;
      Swap(x[k1], x[k2]);
      Swap(y[k1], y[k2]);
      Swap(u[k1], u[k2]);
      Swap(v[k1], v[k2]);
      Swap(hh[k1], hh[k2]);
    end; 
  end;

begin
  Val(ParamStr(1), H, i);
  Val(ParamStr(2), k, i);
  Val(ParamStr(3), L, i);
  Val(ParamStr(4), RandSeed, i);
  XY := ParamStr(5);
  for i := 1 to H do
  begin
    for j := 1 to k do
    begin
      Inc(N);
      x[N] := L*(j-1) + Random(L div 2);
      u[N] := x[N] + Random(L div 2) + 1;
      y[N] := i;
      v[N] := i+1;
      hh[N] := 10;
    end;
  end;
  Shuffle;

  Writeln(N);
  if (XY = 'X') then
  begin
    for i := 1 to N do
      Writeln(x[i], ' ', y[i], ' ', u[i], ' ', v[i], ' ', hh[i]);
  end
  else
  begin
    for i := 1 to N do
      Writeln(y[i], ' ', x[i], ' ', v[i], ' ', u[i], ' ', hh[i]);
  end;
end.